#include <math.h>			 
#include <string.h>


#define prim_ano_bis  1996

typedef struct {
           int ano;
		   int mes;
		   int dia;
		} tfecha;



int bisi(tfecha fecha)
{
 double aux;
 double aux1;
 
 aux = fecha.ano - prim_ano_bis;
 aux = aux / 4;
 aux1 = modf(aux,&aux);
 return(aux1 == 0);
}


int fech_val(tfecha fecha,int *valida)

{
 int bisiesto;

 bisiesto = bisi(fecha);
 *valida = 0;
 if ((fecha.mes == 1) || (fecha.mes == 3) || (fecha.mes == 5) || (fecha.mes == 7) || (fecha.mes == 8) || (fecha.mes == 10) || (fecha.mes == 12))
	{
	  *valida = ((fecha.dia <= 31) && (fecha.dia >= 1));
	}
 else
	{
	  if ((fecha.mes == 4) || (fecha.mes == 6) ||(fecha.mes == 9) ||(fecha.mes == 11))
		{
		  	  *valida = ((fecha.dia <= 30) && (fecha.dia >= 1));
		}
	  else
		{
		  if (bisiesto)
			{
		  	  *valida = ((fecha.dia <= 29) && (fecha.dia >= 1));
			}
		  else
			{
		  	  *valida = ((fecha.dia <= 28) && (fecha.dia >= 1));
			}
		}
	}
 return(0);
}

int di_mas(tfecha *fecha)
{
 int valida;
 
 

 valida = 0;
 while (!valida)
	{
	 fecha->dia = fecha->dia + 1;
	 if (fecha->dia > 31)
		{
		 fecha->mes ++;
		 fecha->dia = 1;
		 if (fecha->mes > 12)
			{
			 fecha->ano++;
			 fecha->mes = 1;
			}
		}
	 fech_val(*fecha,&valida);
	}
 return(0);
}

int di_menos(tfecha *fecha)
{
 int valida;
  
 valida = 0;
 while (!valida)
	{
	 fecha->dia = fecha->dia - 1;
	 if (fecha->dia < 1)
		{
		 fecha->mes --;
		 fecha->dia = 31;
		 if (fecha->mes < 1)
			{
			 fecha->ano--;
			 fecha->mes = 12;
			}
		}
	 fech_val(*fecha,&valida);
	}
 return(0);
}

int int_to_stru (long fecha,tfecha *fecha1)
{
  double aux;


  aux = fecha / 10000;
  modf(aux,&aux);
  fecha1->ano = aux;
  fecha = fecha - aux * 10000;
  aux = fecha / 100;
  modf(aux,&aux);
  fecha1->mes = aux;
  fecha = fecha - aux * 100;
  fecha1->dia = fecha;
  return(0);
}

 int stru_to_int(tfecha fecha1, long *fecha )
{
  long aux,aux1; /* son necesarias para que me haga la operacionde multiplicacion entre argumentos de tipo long, sino los pasa a enteros */

  aux = fecha1.ano;
  aux1 = 10000;
  *fecha =  aux * aux1;  
  *fecha = *fecha + fecha1.mes * 100;
  *fecha = *fecha + fecha1.dia;
  return(0);
}


int fecha_mayor(tfecha fecha1,tfecha fecha2)
{ int aux;
        aux =  (fecha1.ano > fecha2.ano)  || ((fecha1.ano == fecha2.ano) && (fecha1.mes > fecha2.mes)) || ((fecha1.ano == fecha2.ano) && (fecha1.mes == fecha2.mes) && (fecha1.dia > fecha2.dia));
	return(aux);
}

long dias_ano(tfecha *fecha_aux, tfecha fecha_has)
{
    long dias = 0;
    int bisiesto;

	fecha_aux->ano++;
    for(dias=0;!fecha_mayor(*fecha_aux,fecha_has);fecha_aux->ano++)
        {
            bisiesto = bisi(*fecha_aux);
            if (bisiesto && fecha_aux->mes > 2)
                {
                    dias = dias + 366;
                }
            else
                {
                    fecha_aux->ano--;
                    bisiesto = bisi(*fecha_aux);
                    fecha_aux->ano++;
                    if (bisiesto && fecha_aux->mes <= 2)
                        {
                            dias = dias + 366;
                        }
                    else
                        {
                            dias = dias + 365;
                        }


                }
        }
    fecha_aux->ano--;
    return(dias);
}


int dias_mes(tfecha *fecha_aux,tfecha fecha_has) /* esta es una solucion rapida pero no optima, pero se supone que el las computadoras modernas cuentan rapido hasta 374 aprox. */
{
	int dias = 0;

	for(dias=0;!fecha_mayor(*fecha_aux,fecha_has);di_mas(fecha_aux))
        {
			dias++;
        }
	dias--;
    return(dias);
}



long dif_dia (tfecha fecha_des,tfecha fecha_has) /*Calula dias con aos en el rango ao 0 y mas del ao 35000 */
{
    long dias;

    dias = dias_ano(&fecha_des,fecha_has);
	dias = dias + dias_mes(&fecha_des,fecha_has);
    return (dias);
 }




/* --------------------------------------------------------------------- */
/* Funciones para exportar                                               */

int fecha_val (long fecha,int *valida)

{
 tfecha fecha1;


/* if ((fecha < 99999999) && (fecha > 9999999))*/
	{
     int_to_stru(fecha,&fecha1);
     fech_val (fecha1,valida);
	}
/* else
	{
     *valida = 0;
	}*/
 return(0);
}

int dia_mas(long *fecha)

{
  int valida;
  tfecha fecha1;

  fecha_val(*fecha,&valida);
  if (valida)
	{
	  int_to_stru(*fecha,&fecha1);
	  di_mas(&fecha1);
	}
  stru_to_int(fecha1,fecha);
  return(0);
}

int dia_menos(long *fecha)

{
  int valida;
  tfecha fecha1;

  fecha_val(*fecha,&valida);
  if (valida)
	{
	  int_to_stru(*fecha,&fecha1);
	  di_menos(&fecha1);
	}
  stru_to_int(fecha1,fecha);
  return(0);
}

int dif_dias (long fecha_des,long fecha_has,long *diferencia)

{
    int valida,valida1;
    tfecha fecha1,fecha2;
	long aux;

    fecha_val(fecha_des,&valida);
    fecha_val(fecha_has,&valida1);
    if (valida && valida1)
        {
           if (fecha_des > fecha_has)
             {
                aux = fecha_des;
                fecha_des = fecha_has;
                fecha_has = aux;
             }
		   int_to_stru(fecha_des,&fecha1);
           int_to_stru(fecha_has,&fecha2);
		   *diferencia = dif_dia(fecha1,fecha2);
        }
    return(0);
}

int dia_sem (long fecha,char dia[9])
{
	long dias;
	int dia_sem;
	tfecha fecha1;
	tfecha fecha_com; /* esta fecha cae domingo */
        long fecha_comi = 19990801;  /* esta fecha cae domingo */

	int_to_stru(fecha,&fecha1);
        int_to_stru(fecha_comi,&fecha_com);
        dif_dias(fecha,fecha_comi,&dias);
	dia_sem = fmod(dias,7);
	if (fecha_mayor(fecha_com,fecha1))
		{
			dia_sem = 7 - dia_sem;
		}
	switch (dia_sem)
		{
			case 0: strcpy(dia,"Domingo"); break;
			case 1: strcpy(dia,"Lunes  "); break;
			case 2: strcpy(dia,"Martes "); break;
			case 3: strcpy(dia,"Mircoles"); break;
			case 4: strcpy(dia,"Jueves "); break;
			case 5: strcpy(dia,"Viernes"); break;
			case 6: strcpy(dia,"Sbado "); break;
                        case 7: strcpy(dia,"Domingo"); break;
		}
	return (0);
}
